# greenland-runtime -- Common runtime for greenland programs.
# Copyright (C) 2024
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


from greenland.runtime.module_aware_objects import ModuleAwareObject


class ModuleNamePrinter(ModuleAwareObject):

    def __init__(self, name = None):
        self._module_name = name

    def bind(self, module_name: str, module):
        return self.__class__(module_name)

    def __call__(self):
        print(self._module_name)


print_module_name = ModuleNamePrinter()
